/*
 * *************************************************
 * Copyright (c) 2019 QMTH. All Rights Reserved.
 * Created by Deason on 2019-03-07 13:53:38.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.questions.starter;

import cn.com.qmth.examcloud.core.questions.base.enums.ExamFileType;
import cn.com.qmth.examcloud.core.questions.base.enums.ExportWay;
import cn.com.qmth.examcloud.core.questions.service.ExtractConfigFileService;
import cn.com.qmth.examcloud.core.questions.service.bean.dto.ExportPaperInfoModel;
import cn.com.qmth.examcloud.core.questions.service.temp.CqdxService;
import cn.com.qmth.examcloud.core.questions.service.temp.DdExcelService;
import cn.com.qmth.examcloud.web.support.Naked;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;

@Controller
@RequestMapping("${api_cqb}/")
public class IndexController {
    private static final Logger log = LoggerFactory.getLogger(IndexController.class);

    @Naked
    @ResponseBody
    @RequestMapping(value = "/paper/init", method = RequestMethod.GET)
    public String init(HttpServletRequest request, HttpServletResponse response) throws Exception {
        /* 重庆大学xml转paper对象入库 */
        CqdxService cqdxService = SpringContextHolder.getBean(CqdxService.class);
//        cqdxService.bulidPaper();

        DdExcelService ddExcelService = SpringContextHolder.getBean(DdExcelService.class);
//        ddExcelService.exportPaperStructExcel("371");

//        exportExtractExcel(response);
//        exportQuestionExcel();

        return "ok";
    }

    private void exportExtractExcel(HttpServletResponse response) {
        //用来导出调卷规则中，生成的主观题和客观题的Excel(导出调卷规则)
        ExtractConfigFileService service = SpringContextHolder.getBean(ExtractConfigFileService.class);
        ExportPaperInfoModel model = new ExportPaperInfoModel();
        model.setExamId("454");
        model.setExportWay(ExportWay.BATCH);
        List<String> list = new ArrayList<>();
        list.add(ExamFileType.PAPER_STRUCTURE_OBJECTIVE.name());
        model.setExportContentList(list);
        try {
            service.exportExamPaperInfo(model, response, "feng", null, null);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
    }

    private void exportQuestionExcel() {
        //用来导出给定课程关联中的主观题信息的Excel(导出课程下的主观题试题分布)
        DdExcelService ddExcelService = SpringContextHolder.getBean(DdExcelService.class);
        List<String> codes = new ArrayList<>();
        codes.add("GX001.1");
        codes.add("GX001.2");
        codes.add("GX001.4");
        codes.add("G0005");
        codes.add("G0010");
        codes.add("ZJZ004");

        try {
            ddExcelService.exportSubQues("371", 360L, codes);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
    }

}